
package de.ivu.elect.presentation.niederschrift;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturBoundaryCreate;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrekturMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractNiederschriftKorrekturCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractNiederschriftKorrekturCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.NIEDERSCHRIFT_KORREKTUR_CREATE)
public abstract class AbstractNiederschriftKorrekturCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<NiederschriftKorrektur> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "niederschriftKorrekturCreateView";

  public static final String VIEW_ID = "/niederschrift/niederschrift-korrektur-create.xhtml";

  public static final String PARENT_VIEW_ID = "/niederschrift/niederschrift-korrektur-search.xhtml";

  @Inject
  protected transient NiederschriftKorrekturBoundaryCreate create;

  protected NiederschriftKorrektur entity;

  @Inject
  protected transient NiederschriftKorrekturMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  NiederschriftKorrektur());
  }

  

  public NiederschriftKorrektur getEntity() {
    return entity;
  }

  protected void setEntity(NiederschriftKorrektur entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(NiederschriftKorrektur entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(NiederschriftKorrektur entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
